Attribute VB_Name = "modWinball"

Option Explicit

Public Declare Function Rectangle _
    Lib "gdi32.dll" _
    (ByVal hdc As Long, _
    ByVal X1 As Long, _
    ByVal Y1 As Long, _
    ByVal X2 As Long, _
    ByVal Y2 As Long) _
    As Long

Public Declare Function Ellipse _
    Lib "gdi32.dll" _
    (ByVal hdc As Long, _
    ByVal X1 As Long, _
    ByVal Y1 As Long, _
    ByVal X2 As Long, _
    ByVal Y2 As Long) _
    As Long

Public Declare Function BitBlt _
    Lib "gdi32.dll" _
    (ByVal hDestDC As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long, _
    ByVal hSrcDC As Long, _
    ByVal xSrc As Long, _
    ByVal ySrc As Long, _
    ByVal dwRop As Long) _
    As Long

Public Declare Function sndPlaySound _
    Lib "winmm.dll" _
    Alias "sndPlaySoundA" _
    (ByVal lpszSoundName As String, _
    ByVal uFlags As Long) _
    As Long
    
Public Declare Function GetTickCount _
    Lib "kernel32.dll" _
    () As Long

Public Declare Function GetKeyState _
    Lib "user32.dll" _
    (ByVal nVirtKey As Long) _
    As Integer

Public Declare Sub Sleep _
    Lib "kernel32.dll" _
    (ByVal dwMilliseconds As Long)
    
Public Declare Function FSOUND_Init _
    Lib "fmod.dll" _
    Alias "_FSOUND_Init@12" _
    (ByVal mixrate As Long, _
    ByVal maxchannels As Long, _
    ByVal Flags As Long) _
    As Byte
    
Public Declare Function FSOUND_Close _
    Lib "fmod.dll" _
    Alias "_FSOUND_Close@0" () _
    As Long
    
Public Declare Function FMUSIC_SetMasterVolume _
    Lib "fmod.dll" _
    Alias "_FMUSIC_SetMasterVolume@8" _
    (ByVal module As Long, _
    ByVal volume As Long) _
    As Byte
    
Public Declare Function FMUSIC_LoadSong _
    Lib "fmod.dll" _
    Alias "_FMUSIC_LoadSong@4" _
    (ByVal name As String) _
    As Long
    
Public Declare Function FMUSIC_PlaySong _
    Lib "fmod.dll" _
    Alias "_FMUSIC_PlaySong@4" _
    (ByVal module As Long) _
    As Byte
    
Public Declare Function FMUSIC_StopSong _
    Lib "fmod.dll" _
    Alias "_FMUSIC_StopSong@4" _
    (ByVal module As Long) _
    As Byte
    
Public Declare Function FMUSIC_FreeSong _
    Lib "fmod.dll" _
    Alias "_FMUSIC_FreeSong@4" _
    (ByVal module As Long) _
    As Byte

Public Declare Function InternetAttemptConnect _
    Lib "wininet.dll" _
    (ByVal dwReserved As Long) _
    As Long

Public Declare Function ShellExecute _
    Lib "shell32.dll" _
    Alias "ShellExecuteA" _
    (ByVal hwnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) _
    As Long

Public Const SRCAND = &H8800C6
Public Const SRCCOPY = &HCC0020
Public Const SRCINVERT = &H660046
Public Const SND_ASYNC = &H1
Public Const SND_FILENAME = &H20000
Public Const SND_NODEFAULT = &H2
Public Const VK_LEFT = &H25
Public Const VK_RIGHT = &H27
Public Const VK_UP = &H26
Public Const VK_DOWN = &H28
Public Const VK_SPACE = &H20
Public Const SW_SHOWNORMAL = 1

Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Type PLAYERINFO
    PadPos As POINTAPI
    PadSize As POINTAPI
    PadMove As POINTAPI
    PadPoint(0 To 1) As POINTAPI
    SlamPoint(0 To 1) As POINTAPI
    TurboPoint(0 To 1) As POINTAPI
    Turbo As Integer
    Slam As Integer
    Score As Integer
    Scores As Byte
    kTurbo As Byte
    kSlam As Byte
    kLeft As Byte
    kRight As Byte
    kUp As Byte
    kDown As Byte
    kS As Byte
    kX As Byte
End Type

Public Type BALLINFO
    XPos As Integer
    YPos As Integer
    ZPos As Integer
    XMove As Integer
    YMove As Integer
    ZMove As Integer
End Type

Public Type VISBINFO
    XPos As Integer
    YPos As Integer
    Size As Integer
End Type

Public PLR As PLAYERINFO, CPU As PLAYERINFO
Public BallZInd(0 To 1) As POINTAPI
Public Ball As BALLINFO, VisBall As VISBINFO
Public bStop As Byte, bPause As Byte, bQuit As Byte
Public PlayTime&, lFMusic&
Public sFMusic$, sStatus$
Public MaxScore%, MaxLoops%
Public PScore%, n%, CurScore%
Public iSpeed%, iVol%
Public bSounds As Byte, bAssists As Byte
Public bHardCPU As Byte, bFMod As Byte

Public Sub Do_GameLoop()

    Reset_Field
    PLR.Score = 0
    CPU.Score = 0
    frmMain.lblGameStats.Caption = "Scores: P0, C0"
    frmMain.lblLoop.Caption = ""
    Ball.ZMove = 1
    If Int(Rnd * 2) = 0 Then Ball.ZMove = -1 * Ball.ZMove
    PlayTime = GetTickCount

    Do
        
        DoEvents
        If bPause Then GoTo Skipped
        Check_Keys
        Do_PLR
        Do_CPU
        Do_Ball
        Draw_Things
                
        If PLR.Scores Or CPU.Scores Then
        
            If PLR.Scores Then
                Ball.ZMove = 1
                PLR.Score = PLR.Score + CurScore
                Play_Sound "Score1"
            Else
                Ball.ZMove = -1
                CPU.Score = CPU.Score + CurScore
                Play_Sound "Score2"
            End If
            
            With frmMain.picMain
            
                If PLR.Scores Then
                    .FillColor = vbGreen
                Else: .FillColor = vbRed
                End If
            
                For n = 0 To 3
                
                    If n = 0 Then
                        .FillStyle = 6
                    ElseIf n = 1 Then
                        .FillStyle = 7
                    ElseIf n = 2 Then
                        .FillStyle = 0
                    End If
                
                    If n = 3 Then
                        If PLR.Scores Then
                            .FillColor = RGB(0, 128, 0)
                        Else: .FillColor = RGB(128, 0, 0)
                        End If
                    End If
                                
                    Rectangle .hdc, BallZInd(0).x, _
                    BallZInd(0).y, BallZInd(1).x, _
                    BallZInd(1).y
                
                    Sleep 75
            
                Next
            
            End With
            frmMain.lblGameStats.Caption = _
            "Scores: P" & PLR.Score & ", C" & CPU.Score
        
            Reset_Field
        
        End If
        
        If MaxScore > 0 Then
            If (PLR.Score >= MaxScore) Or _
            (CPU.Score >= MaxScore) Then bStop = 1
        End If
        
        If MaxLoops > 0 Then MaxLoops = MaxLoops - 1
        If MaxLoops >= 0 Then
            frmMain.lblLoop.Caption = "Loops left: " & MaxLoops
        End If
        If MaxLoops = 0 Then bStop = 1
        
        Sleep 40 - 4 * iSpeed
    
Skipped:
    
        If bQuit Then Exit Do
    
    Loop While bStop = 0
    
    bStop = 0
    bPause = 0
    
    With frmMain

        .mnuStop.Enabled = False
        .mnuPause.Checked = False
        .mnuPause.Enabled = False
        .imgPause.Visible = False
        .picMain.Picture = LoadPicture()
        .lblPScore.Caption = "Score: " & PLR.Score
        .lblCScore.Caption = "Score: " & CPU.Score
        If CPU.Score > PLR.Score Then
            .lblWinner.Caption = "Computer"
        ElseIf CPU.Score < PLR.Score Then
            .lblWinner.Caption = "Player"
        Else: .lblWinner.Caption = "-"
        End If
    
Dim lMin&, lSec&
        
        lMin = (GetTickCount - PlayTime) \ 60000
        lSec = Int((GetTickCount - PlayTime) / 1000) - 60 * lMin
        
        .lblSpentTime.Caption = lMin & "min " & lSec & "s"
        .shpDCross.Visible = False
        .FrameMain.Visible = True
        .tmrTitle.Enabled = True
    
    End With

End Sub

Public Sub Play_Sound(sWave As String)

    If bSounds = 1 Then
        sndPlaySound App.Path & "\" & sWave & ".wav", _
        SND_ASYNC Or SND_FILENAME Or SND_NODEFAULT
    End If

End Sub

Public Sub Reset_Field()

    CurScore = 10
    PLR.PadPos.x = 320
    PLR.PadPos.y = 240
    PLR.PadMove.x = 0
    PLR.PadMove.y = 0
    PLR.PadSize.x = 128
    PLR.PadSize.y = 64
    PLR.Scores = 0
    PLR.Slam = 0
    PLR.Turbo = 510
    PLR.kSlam = 0
    CPU.PadPos.x = 320
    CPU.PadPos.y = 240
    CPU.PadMove.x = 0
    CPU.PadMove.y = 0
    CPU.PadSize.x = 128
    CPU.PadSize.y = 64
    CPU.Scores = 0
    CPU.Slam = 0
    CPU.Turbo = 510
    CPU.kSlam = 0
    Ball.XPos = 320
    Ball.YPos = 240
    Ball.ZPos = 96
    Ball.XMove = 0
    Ball.YMove = 0

End Sub

Public Sub Check_Keys()

    If (GetKeyState(VK_LEFT) And &HF0000000) Then _
    PLR.kLeft = 1 Else PLR.kLeft = 0
    If (GetKeyState(VK_RIGHT) And &HF0000000) Then _
    PLR.kRight = 1 Else PLR.kRight = 0
    If (GetKeyState(VK_UP) And &HF0000000) Then _
    PLR.kUp = 1 Else PLR.kUp = 0
    If (GetKeyState(VK_DOWN) And &HF0000000) Then _
    PLR.kDown = 1 Else PLR.kDown = 0
    If (GetKeyState(vbKeyA) And &HF0000000) Then _
    PLR.kTurbo = 1 Else PLR.kTurbo = 0
    If (GetKeyState(vbKeyS) And &HF0000000) Then _
    PLR.kS = 1 Else PLR.kS = 0
    If (GetKeyState(vbKeyX) And &HF0000000) Then _
    PLR.kX = 1 Else PLR.kX = 0
    If (GetKeyState(VK_SPACE) And &HF0000000) Then _
    PLR.kSlam = 1 Else PLR.kSlam = 0
    
End Sub

Public Sub Do_PLR()

    PLR.PadMove.x = 0
    PLR.PadMove.y = 0
    PLR.PadMove.x = -4 * PLR.kLeft
    If PLR.PadMove.x = 0 Then PLR.PadMove.x = 4 * PLR.kRight
    PLR.PadMove.y = -4 * PLR.kUp
    If PLR.PadMove.y = 0 Then PLR.PadMove.y = 4 * PLR.kDown
    
    If PLR.Turbo < 510 Then PLR.Turbo = PLR.Turbo + 1
    If PLR.kTurbo And PLR.Turbo > 4 Then
        PLR.Turbo = PLR.Turbo - 5
        PLR.PadMove.x = 2 * PLR.PadMove.x
        PLR.PadMove.y = 2 * PLR.PadMove.y
    End If
    
    PLR.PadPos.x = PLR.PadPos.x + PLR.PadMove.x
    PLR.PadPos.y = PLR.PadPos.y + PLR.PadMove.y
    
    If PLR.kS And PLR.PadSize.x > 64 Then
        PLR.PadSize.y = PLR.PadSize.y + 4
        PLR.PadSize.x = PLR.PadSize.x - 4
    End If
    If PLR.kX And PLR.PadSize.y > 32 Then
        PLR.PadSize.x = PLR.PadSize.x + 4
        PLR.PadSize.y = PLR.PadSize.y - 4
    End If

    If (PLR.PadPos.x - PLR.PadSize.x / 2) < 0 Then _
    PLR.PadPos.x = 0 + PLR.PadSize.x / 2
    If (PLR.PadPos.x + PLR.PadSize.x / 2) > 640 Then _
    PLR.PadPos.x = 640 - PLR.PadSize.x / 2
    If (PLR.PadPos.y - PLR.PadSize.y / 2) < 0 Then _
    PLR.PadPos.y = 0 + PLR.PadSize.y / 2
    If (PLR.PadPos.y + PLR.PadSize.y / 2) > 480 Then _
    PLR.PadPos.y = 480 - PLR.PadSize.y / 2

    PLR.PadPoint(0).x = PLR.PadPos.x - PLR.PadSize.x / 2
    PLR.PadPoint(0).y = PLR.PadPos.y - PLR.PadSize.y / 2
    PLR.PadPoint(1).x = PLR.PadPos.x + PLR.PadSize.x / 2
    PLR.PadPoint(1).y = PLR.PadPos.y + PLR.PadSize.y / 2
    
    If PLR.Slam < 0 Then PLR.Slam = PLR.Slam + 1
    
    If PLR.kSlam Then
        
        PLR.Slam = PLR.Slam + 1
        If PLR.Slam = 21 Then
            Play_Sound "Miss"
            PLR.Slam = -2 * PLR.Slam
        End If
        
    Else
    
        If PLR.Slam > 0 Then
            Play_Sound "Miss"
            PLR.Slam = -2 * PLR.Slam
        End If
        
    End If
    
    If PLR.Slam < 0 Then
        PLR.SlamPoint(1).y = 470
    Else: PLR.SlamPoint(1).y = 470 - 23 * PLR.Slam
    End If

End Sub

Public Sub Do_CPU()
    
    CPU.PadMove.x = 0
    CPU.PadMove.y = 0
    CPU.kLeft = 0
    CPU.kRight = 0
    CPU.kUp = 0
    CPU.kDown = 0
    CPU.kTurbo = 0
    
    If Ball.XPos < CPU.PadPos.x - 8 Then
        CPU.PadMove.x = -4 - bHardCPU
        CPU.kLeft = 1
    ElseIf Ball.XPos > CPU.PadPos.x + 8 Then
        CPU.PadMove.x = 4 + bHardCPU
        CPU.kRight = 1
    End If
    If Ball.YPos < CPU.PadPos.y - 8 Then
        CPU.PadMove.y = -4 - bHardCPU
        CPU.kUp = 1
    ElseIf Ball.YPos > CPU.PadPos.y + 8 Then
        CPU.PadMove.y = 4 + bHardCPU
        CPU.kDown = 1
    End If
    CPU.PadPos.x = CPU.PadPos.x + CPU.PadMove.x
    CPU.PadPos.y = CPU.PadPos.y + CPU.PadMove.y
        
    If (Ball.XPos < CPU.PadPos.x - CPU.PadSize.x / 2 + 4) _
    Or (Ball.XPos > CPU.PadPos.x + CPU.PadSize.x / 2 - 4) Then
        If CPU.PadSize.y > 32 Then
            CPU.PadSize.x = CPU.PadSize.x + 4
            CPU.PadSize.y = CPU.PadSize.y - 4
        End If
    End If
    If (Ball.YPos < CPU.PadPos.y - CPU.PadSize.y / 2 + 4) _
    Or (Ball.YPos > CPU.PadPos.y + CPU.PadSize.y / 2 - 4) Then
        If CPU.PadSize.x > 64 Then
            CPU.PadSize.y = CPU.PadSize.y + 4
            CPU.PadSize.x = CPU.PadSize.x - 4
        End If
    End If
    
    If CPU.Turbo < 510 Then CPU.Turbo = CPU.Turbo + 1
    If CPU.Turbo > 4 Then
    
        If Ball.XPos < CPU.PadPos.x - CPU.PadSize.x / 2 + 8 Then
            CPU.PadPos.x = CPU.PadPos.x - 4 - bHardCPU
            CPU.PadMove.x = CPU.PadMove.x - 4 - bHardCPU
            CPU.kTurbo = 1
        ElseIf Ball.XPos > CPU.PadPos.x + CPU.PadSize.x / 2 - 8 Then
            CPU.PadPos.x = CPU.PadPos.x + 4 + bHardCPU
            CPU.PadMove.x = CPU.PadMove.x + 4 + bHardCPU
            CPU.kTurbo = 1
        End If
        If Ball.YPos < CPU.PadPos.y - CPU.PadSize.y / 2 + 8 Then
            CPU.PadPos.y = CPU.PadPos.y - 4 - bHardCPU
            CPU.PadMove.y = CPU.PadMove.y - 4 - bHardCPU
            CPU.kTurbo = 1
        ElseIf Ball.YPos > CPU.PadPos.y + CPU.PadSize.y / 2 - 8 Then
            CPU.PadPos.y = CPU.PadPos.y + 4 + bHardCPU
            CPU.PadMove.y = CPU.PadMove.y + 4 + bHardCPU
            CPU.kTurbo = 1
        End If
        
    End If
    
    If CPU.kTurbo Then CPU.Turbo = CPU.Turbo - 5
    
    If (CPU.PadPos.x - CPU.PadSize.x / 2) < 0 Then _
    CPU.PadPos.x = 0 + CPU.PadSize.x / 2
    If (CPU.PadPos.x + CPU.PadSize.x / 2) > 640 Then _
    CPU.PadPos.x = 640 - CPU.PadSize.x / 2
    If (CPU.PadPos.y - CPU.PadSize.y / 2) < 0 Then _
    CPU.PadPos.y = 0 + CPU.PadSize.y / 2
    If (CPU.PadPos.y + CPU.PadSize.y / 2) > 480 Then _
    CPU.PadPos.y = 480 - CPU.PadSize.y / 2
    
    CPU.PadPoint(0).x = 192 + CPU.PadPos.x / 2.5 - CPU.PadSize.x / 5
    CPU.PadPoint(0).y = 144 + CPU.PadPos.y / 2.5 - CPU.PadSize.y / 5
    CPU.PadPoint(1).x = 192 + CPU.PadPos.x / 2.5 + CPU.PadSize.x / 5
    CPU.PadPoint(1).y = 144 + CPU.PadPos.y / 2.5 + CPU.PadSize.y / 5

    If CPU.Slam < 0 Then CPU.Slam = CPU.Slam + 1
    
    If CPU.Slam >= 0 And CPU.kSlam = 0 _
    And Ball.ZMove > 0 And bHardCPU = 1 Then
        
        If (192 - Ball.ZPos) / Ball.ZMove <= _
        20 - Int(Rnd * 6) Then CPU.kSlam = 1
    
    ElseIf CPU.Slam >= 0 And CPU.kSlam = 0 _
    And Ball.ZMove > 0 Then
    
        If (192 - Ball.ZPos) / Ball.ZMove <= _
        20 - Int(Rnd * 15) Then CPU.kSlam = 1
    
    End If
    
    If Int(Rnd * (30 + 30 * bHardCPU)) = 0 Then CPU.kSlam = 0
    If CPU.kSlam Then
        
        CPU.Slam = CPU.Slam + 1
        If CPU.Slam = 21 Then
            Play_Sound "Miss"
            CPU.Slam = -2 * CPU.Slam
            CPU.kSlam = 0
        End If
        
    Else
    
        If CPU.Slam > 0 Then
            Play_Sound "Miss"
            CPU.Slam = -2 * CPU.Slam
        End If
        
    End If
    
    If CPU.Slam < 0 Then
        CPU.SlamPoint(1).y = 10
    Else: CPU.SlamPoint(1).y = 10 + 23 * CPU.Slam
    End If

End Sub

Public Sub Do_Ball()

    Ball.XPos = Ball.XPos + Ball.XMove
    Ball.YPos = Ball.YPos + Ball.YMove
    Ball.ZPos = Ball.ZPos + Ball.ZMove
    
    If Ball.XPos <= 16 Then
        Ball.XMove = -1 * Ball.XMove
        Ball.XPos = 32 - Ball.XPos
        Play_Sound "Ballhit1"
    ElseIf Ball.XPos >= 624 Then
        Ball.XMove = -1 * Ball.XMove
        Ball.XPos = 1248 - Ball.XPos
        Play_Sound "Ballhit1"
    End If
    If Ball.YPos <= 16 Then
        Ball.YMove = -1 * Ball.YMove
        Ball.YPos = 32 - Ball.YPos
        Play_Sound "Ballhit1"
    ElseIf Ball.YPos >= 464 Then
        Ball.YMove = -1 * Ball.YMove
        Ball.YPos = 928 - Ball.YPos
        Play_Sound "Ballhit1"
    End If
    
    VisBall.Size = 32 - Ball.ZPos / 10
    If VisBall.Size > 32 Then VisBall.Size = 32
    
    VisBall.XPos = Ball.ZPos + _
    Ball.XPos * (1 - Ball.ZPos / 320) - VisBall.Size / 2
    VisBall.YPos = 0.75 * Ball.ZPos _
    + Ball.YPos * (1 - Ball.ZPos / 320) - VisBall.Size / 2
        
    BallZInd(0).x = Ball.ZPos
    BallZInd(0).y = 0.75 * Ball.ZPos
    BallZInd(1).x = 640 - Ball.ZPos
    BallZInd(1).y = 480 - 0.75 * Ball.ZPos
    
    If Ball.ZPos <= 0 Then
    
        If (Ball.XPos >= PLR.PadPoint(0).x) _
        And (Ball.XPos <= PLR.PadPoint(1).x) _
        And (Ball.YPos >= PLR.PadPoint(0).y) _
        And (Ball.YPos <= PLR.PadPoint(1).y) Then
    
            Ball.ZMove = -1 * Ball.ZMove
            Ball.ZPos = 0 - Ball.ZPos
            Ball.XMove = Ball.XMove + PLR.PadMove.x / 4
            Ball.YMove = Ball.YMove + PLR.PadMove.y / 4
            
            If PLR.Slam > 0 Then
            
                Ball.ZMove = Ball.ZMove + Int(PLR.Slam / 7)
                Play_Sound "Ballhit3"
                PLR.Slam = -2 * PLR.Slam
                
            Else
                
                Ball.ZMove = Int(Ball.ZMove * 0.9 + 0.1)
                Play_Sound "Ballhit2"
                
            End If
            
            CurScore = CurScore + PScore
            
        Else: CPU.Scores = 1
                
        End If
    
    ElseIf Ball.ZPos >= 192 Then
    
        If (Ball.XPos >= CPU.PadPos.x - CPU.PadSize.x / 2) _
        And (Ball.XPos <= CPU.PadPos.x + CPU.PadSize.x / 2) _
        And (Ball.YPos >= CPU.PadPos.y - CPU.PadSize.y / 2) _
        And (Ball.YPos <= CPU.PadPos.y + CPU.PadSize.y / 2) Then
    
            Ball.ZMove = -1 * Ball.ZMove
            Ball.ZPos = 384 - Ball.ZPos
            If bHardCPU = 1 And CPU.PadMove.x = 0 Then
                If Ball.XMove < 0 Then
                    Ball.XMove = Ball.XMove - 1
                ElseIf Ball.XMove > 0 Then
                    Ball.XMove = Ball.XMove + 1
                Else: Ball.XMove = 1 - Int(Rnd * 3)
                End If
            Else: Ball.XMove = Ball.XMove + CPU.PadMove.x / 4
            End If
            If bHardCPU = 1 And CPU.PadMove.y = 0 Then
                If Ball.YMove < 0 Then
                    Ball.YMove = Ball.YMove - 1
                ElseIf Ball.YMove > 0 Then
                    Ball.YMove = Ball.YMove + 1
                Else: Ball.YMove = 1 - Int(Rnd * 3)
                End If
            Else: Ball.YMove = Ball.YMove + CPU.PadMove.y / 4
            End If
            
            If CPU.Slam > 0 Then
            
                Ball.ZMove = Ball.ZMove - Int(CPU.Slam / 7)
                Play_Sound "Ballhit3"
                CPU.Slam = -2 * CPU.Slam
                CPU.kSlam = 0
                
            Else
                
                Ball.ZMove = Int(Ball.ZMove * 0.9 + 0.1)
                Play_Sound "Ballhit2"
                
            End If
            
            CurScore = CurScore + PScore
        
        Else: PLR.Scores = 1
        
        End If
    
    End If
    
End Sub

Public Sub Draw_Things()

    With frmMain.picBuffer
        
        .Cls
        
        .DrawWidth = 1
        .ForeColor = vbRed
        .FillColor = RGB(128, 0, 0)
        .FillStyle = 7
        Rectangle .hdc, CPU.PadPoint(0).x, _
        CPU.PadPoint(0).y, CPU.PadPoint(1).x, _
        CPU.PadPoint(1).y
        
        If bAssists = 1 Then
        
            .FillStyle = 1
            .ForeColor = vbWhite
            Rectangle .hdc, BallZInd(0).x, _
            BallZInd(0).y, BallZInd(1).x, _
            BallZInd(1).y
        
        End If

        BitBlt .hdc, VisBall.XPos, VisBall.YPos, _
        frmMain.picBall(VisBall.Size).Height, _
        frmMain.picBall(VisBall.Size).Height, _
        frmMain.picBall(VisBall.Size).hdc, 0, 0, SRCAND
        
        BitBlt .hdc, VisBall.XPos, VisBall.YPos, _
        frmMain.picBall(VisBall.Size).Height, _
        frmMain.picBall(VisBall.Size).Height, _
        frmMain.picBall(VisBall.Size).hdc, _
        frmMain.picBall(VisBall.Size).Width / 2, 0, SRCINVERT

        .DrawWidth = 2
        .ForeColor = vbGreen
        .FillColor = RGB(0, 128, 0)
        .FillStyle = 7
        Rectangle .hdc, PLR.PadPoint(0).x, _
        PLR.PadPoint(0).y, PLR.PadPoint(1).x, _
        PLR.PadPoint(1).y
        
        .FillColor = RGB(0, 192, 0)
        .FillStyle = 4
        Rectangle .hdc, PLR.SlamPoint(0).x, _
        PLR.SlamPoint(0).y, PLR.SlamPoint(1).x, _
        PLR.SlamPoint(1).y
        
        .DrawWidth = 1
        .ForeColor = RGB(0, 128, 0)
        .FillColor = RGB(0, Int(PLR.Turbo / 2), 0)
        .FillStyle = 0
        Ellipse .hdc, PLR.TurboPoint(0).x, _
        PLR.TurboPoint(0).y, PLR.TurboPoint(1).x, _
        PLR.TurboPoint(1).y
    
        If bAssists = 1 Then
                
            .ForeColor = RGB(128, 0, 0)
            .FillColor = RGB(Int(CPU.Turbo / 2), 0, 0)
            .FillStyle = 0
            Ellipse .hdc, CPU.TurboPoint(0).x, _
            CPU.TurboPoint(0).y, CPU.TurboPoint(1).x, _
            CPU.TurboPoint(1).y
            
            .DrawWidth = 2
            .ForeColor = vbRed
            .FillColor = RGB(192, 0, 0)
            .FillStyle = 4
            Rectangle .hdc, CPU.SlamPoint(0).x, _
            CPU.SlamPoint(0).y, CPU.SlamPoint(1).x, _
            CPU.SlamPoint(1).y
        
        End If
            
        BitBlt frmMain.picMain.hdc, 0, 0, _
        640, 480, .hdc, 0, 0, SRCCOPY
    
    End With

End Sub

